﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.UI;
using System.Runtime.InteropServices;

public class Menu : MonoBehaviour
{
    public Button enterGameButton;

    public Button payButton;

    // Start is called before the first frame update
    void Start()
    {
        enterGameButton.onClick.AddListener(EnterGame);
        payButton.onClick.AddListener(Pay);

        Debug.Log("###NebulaInit");
        Nebula.NebulaSDKBridge.Instance.Init("1.0.0");

        Nebula.NebulaSDKBridge.Instance.NebulaDebug(false);

        Nebula.NebulaSDKBridgeCallback.LoginCallback = (loginInfo) =>
        {
            Debug.Log("###LoginCallback>>status:"+ loginInfo.status + ">>code:" + loginInfo.code + ">>msg:" + loginInfo.msg + ">>openId:" + loginInfo.data.openId + ">>unionId:" + loginInfo.data.unionId + ">>token:" + loginInfo.data.token  + ">>nbOpenId:" + loginInfo.data.nbOpenId + ">>nbUnionId:" + loginInfo.data.nbUnionId);

            
            if ("success".Equals(loginInfo.status))
            {
                // 登录成功
            } 
            else
            {
                // 登录失败
            }
        };

        Nebula.NebulaSDKBridgeCallback.PayCallback = (payInfo) =>
        {
            Debug.Log("###PayCallback>>status:"+ payInfo.status + ">>code:" + payInfo.code + ">>msg:" + payInfo.msg + ">>orderNo:" + payInfo.data.orderNo + ">>payType:" + payInfo.
                        data.payType);

            if ("success".Equals(payInfo.status))
            {
                // 支付成功   
            } else
            {
                // 支付失败
            }
        };
    }

    // Update is called once per frame
    void Update()
    {
        
    }

    public void EnterGame() {
        //SceneManager.LoadScene(1);
        Debug.Log("###NebulaLogin");
        Nebula.NebulaSDKBridge.Instance.Login();
    }

    public void Pay() {
        Debug.Log("###NebulaPay");
        string tradeNo = System.DateTimeOffset.UtcNow.ToUnixTimeMilliseconds().ToString();
        Nebula.NebulaSDKBridge.Instance.Pay(100, tradeNo, "1", "100钻石", "1", "1号玩家", "1", "1", "1", "1", "1", 1, "http://example.com", "example");
    }
}
