'use strict';

Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: 'Module' } });

const md5 = (stringValue) => {
  function rotateLeft(lValue, iShiftBits) {
    return lValue << iShiftBits | lValue >>> 32 - iShiftBits;
  }
  function addUnsigned(lX, lY) {
    const lX8 = lX & 2147483648;
    const lY8 = lY & 2147483648;
    const lX4 = lX & 1073741824;
    const lY4 = lY & 1073741824;
    const lResult = (lX & 1073741823) + (lY & 1073741823);
    if (lX4 & lY4) {
      return lResult ^ 2147483648 ^ lX8 ^ lY8;
    }
    if (lX4 | lY4) {
      if (lResult & 1073741824) {
        return lResult ^ 3221225472 ^ lX8 ^ lY8;
      }
      return lResult ^ 1073741824 ^ lX8 ^ lY8;
    }
    return lResult ^ lX8 ^ lY8;
  }
  function F(x2, y, z) {
    return x2 & y | ~x2 & z;
  }
  function G(x2, y, z) {
    return x2 & z | y & ~z;
  }
  function H(x2, y, z) {
    return x2 ^ y ^ z;
  }
  function I(x2, y, z) {
    return y ^ (x2 | ~z);
  }
  function FF(a2, b2, c2, d2, x2, s, ac) {
    const v = addUnsigned(a2, addUnsigned(addUnsigned(F(b2, c2, d2), x2), ac));
    return addUnsigned(rotateLeft(v, s), b2);
  }
  function GG(a2, b2, c2, d2, x2, s, ac) {
    const v = addUnsigned(a2, addUnsigned(addUnsigned(G(b2, c2, d2), x2), ac));
    return addUnsigned(rotateLeft(v, s), b2);
  }
  function HH(a2, b2, c2, d2, x2, s, ac) {
    const v = addUnsigned(a2, addUnsigned(addUnsigned(H(b2, c2, d2), x2), ac));
    return addUnsigned(rotateLeft(v, s), b2);
  }
  function II(a2, b2, c2, d2, x2, s, ac) {
    const v = addUnsigned(a2, addUnsigned(addUnsigned(I(b2, c2, d2), x2), ac));
    return addUnsigned(rotateLeft(v, s), b2);
  }
  function convertToWordArray(value) {
    let lWordCount;
    const lMessageLength = value.length;
    const lNumberOfWords_temp1 = lMessageLength + 8;
    const lNumberOfWords_temp2 = (lNumberOfWords_temp1 - lNumberOfWords_temp1 % 64) / 64;
    const lNumberOfWords = (lNumberOfWords_temp2 + 1) * 16;
    const lWordArray = Array(lNumberOfWords - 1);
    let lBytePosition = 0;
    let lByteCount = 0;
    while (lByteCount < lMessageLength) {
      lWordCount = (lByteCount - lByteCount % 4) / 4;
      lBytePosition = lByteCount % 4 * 8;
      lWordArray[lWordCount] = lWordArray[lWordCount] | value.charCodeAt(lByteCount) << lBytePosition;
      lByteCount += 1;
    }
    lWordCount = (lByteCount - lByteCount % 4) / 4;
    lBytePosition = lByteCount % 4 * 8;
    lWordArray[lWordCount] = lWordArray[lWordCount] | 128 << lBytePosition;
    lWordArray[lNumberOfWords - 2] = lMessageLength << 3;
    lWordArray[lNumberOfWords - 1] = lMessageLength >>> 29;
    return lWordArray;
  }
  function wordToHex(lValue) {
    let WordToHexValue = "";
    let WordToHexValue_temp = "";
    let lByte;
    let lCount;
    for (lCount = 0; lCount <= 3; lCount++) {
      lByte = lValue >>> lCount * 8 & 255;
      WordToHexValue_temp = `0${lByte.toString(16)}`;
      WordToHexValue += WordToHexValue_temp.substr(WordToHexValue_temp.length - 2, 2);
    }
    return WordToHexValue;
  }
  function utf8Encode(value) {
    const normalizeValue = value.replace(/\r\n/ug, "\n");
    let utftext = "";
    for (let n = 0; n < normalizeValue.length; n++) {
      const c2 = normalizeValue.charCodeAt(n);
      if (c2 < 128) {
        utftext += String.fromCharCode(c2);
      } else if (c2 > 127 && c2 < 2048) {
        utftext += String.fromCharCode(c2 >> 6 | 192);
        utftext += String.fromCharCode(c2 & 63 | 128);
      } else {
        utftext += String.fromCharCode(c2 >> 12 | 224);
        utftext += String.fromCharCode(c2 >> 6 & 63 | 128);
        utftext += String.fromCharCode(c2 & 63 | 128);
      }
    }
    return utftext;
  }
  let x = [];
  let k;
  let AA;
  let BB;
  let CC;
  let DD;
  let a;
  let b;
  let c;
  let d;
  const S11 = 7;
  const S12 = 12;
  const S13 = 17;
  const S14 = 22;
  const S21 = 5;
  const S22 = 9;
  const S23 = 14;
  const S24 = 20;
  const S31 = 4;
  const S32 = 11;
  const S33 = 16;
  const S34 = 23;
  const S41 = 6;
  const S42 = 10;
  const S43 = 15;
  const S44 = 21;
  x = convertToWordArray(utf8Encode(stringValue));
  a = 1732584193;
  b = 4023233417;
  c = 2562383102;
  d = 271733878;
  for (k = 0; k < x.length; k += 16) {
    AA = a;
    BB = b;
    CC = c;
    DD = d;
    a = FF(a, b, c, d, x[k + 0], S11, 3614090360);
    d = FF(d, a, b, c, x[k + 1], S12, 3905402710);
    c = FF(c, d, a, b, x[k + 2], S13, 606105819);
    b = FF(b, c, d, a, x[k + 3], S14, 3250441966);
    a = FF(a, b, c, d, x[k + 4], S11, 4118548399);
    d = FF(d, a, b, c, x[k + 5], S12, 1200080426);
    c = FF(c, d, a, b, x[k + 6], S13, 2821735955);
    b = FF(b, c, d, a, x[k + 7], S14, 4249261313);
    a = FF(a, b, c, d, x[k + 8], S11, 1770035416);
    d = FF(d, a, b, c, x[k + 9], S12, 2336552879);
    c = FF(c, d, a, b, x[k + 10], S13, 4294925233);
    b = FF(b, c, d, a, x[k + 11], S14, 2304563134);
    a = FF(a, b, c, d, x[k + 12], S11, 1804603682);
    d = FF(d, a, b, c, x[k + 13], S12, 4254626195);
    c = FF(c, d, a, b, x[k + 14], S13, 2792965006);
    b = FF(b, c, d, a, x[k + 15], S14, 1236535329);
    a = GG(a, b, c, d, x[k + 1], S21, 4129170786);
    d = GG(d, a, b, c, x[k + 6], S22, 3225465664);
    c = GG(c, d, a, b, x[k + 11], S23, 643717713);
    b = GG(b, c, d, a, x[k + 0], S24, 3921069994);
    a = GG(a, b, c, d, x[k + 5], S21, 3593408605);
    d = GG(d, a, b, c, x[k + 10], S22, 38016083);
    c = GG(c, d, a, b, x[k + 15], S23, 3634488961);
    b = GG(b, c, d, a, x[k + 4], S24, 3889429448);
    a = GG(a, b, c, d, x[k + 9], S21, 568446438);
    d = GG(d, a, b, c, x[k + 14], S22, 3275163606);
    c = GG(c, d, a, b, x[k + 3], S23, 4107603335);
    b = GG(b, c, d, a, x[k + 8], S24, 1163531501);
    a = GG(a, b, c, d, x[k + 13], S21, 2850285829);
    d = GG(d, a, b, c, x[k + 2], S22, 4243563512);
    c = GG(c, d, a, b, x[k + 7], S23, 1735328473);
    b = GG(b, c, d, a, x[k + 12], S24, 2368359562);
    a = HH(a, b, c, d, x[k + 5], S31, 4294588738);
    d = HH(d, a, b, c, x[k + 8], S32, 2272392833);
    c = HH(c, d, a, b, x[k + 11], S33, 1839030562);
    b = HH(b, c, d, a, x[k + 14], S34, 4259657740);
    a = HH(a, b, c, d, x[k + 1], S31, 2763975236);
    d = HH(d, a, b, c, x[k + 4], S32, 1272893353);
    c = HH(c, d, a, b, x[k + 7], S33, 4139469664);
    b = HH(b, c, d, a, x[k + 10], S34, 3200236656);
    a = HH(a, b, c, d, x[k + 13], S31, 681279174);
    d = HH(d, a, b, c, x[k + 0], S32, 3936430074);
    c = HH(c, d, a, b, x[k + 3], S33, 3572445317);
    b = HH(b, c, d, a, x[k + 6], S34, 76029189);
    a = HH(a, b, c, d, x[k + 9], S31, 3654602809);
    d = HH(d, a, b, c, x[k + 12], S32, 3873151461);
    c = HH(c, d, a, b, x[k + 15], S33, 530742520);
    b = HH(b, c, d, a, x[k + 2], S34, 3299628645);
    a = II(a, b, c, d, x[k + 0], S41, 4096336452);
    d = II(d, a, b, c, x[k + 7], S42, 1126891415);
    c = II(c, d, a, b, x[k + 14], S43, 2878612391);
    b = II(b, c, d, a, x[k + 5], S44, 4237533241);
    a = II(a, b, c, d, x[k + 12], S41, 1700485571);
    d = II(d, a, b, c, x[k + 3], S42, 2399980690);
    c = II(c, d, a, b, x[k + 10], S43, 4293915773);
    b = II(b, c, d, a, x[k + 1], S44, 2240044497);
    a = II(a, b, c, d, x[k + 8], S41, 1873313359);
    d = II(d, a, b, c, x[k + 15], S42, 4264355552);
    c = II(c, d, a, b, x[k + 6], S43, 2734768916);
    b = II(b, c, d, a, x[k + 13], S44, 1309151649);
    a = II(a, b, c, d, x[k + 4], S41, 4149444226);
    d = II(d, a, b, c, x[k + 11], S42, 3174756917);
    c = II(c, d, a, b, x[k + 2], S43, 718787259);
    b = II(b, c, d, a, x[k + 9], S44, 3951481745);
    a = addUnsigned(a, AA);
    b = addUnsigned(b, BB);
    c = addUnsigned(c, CC);
    d = addUnsigned(d, DD);
  }
  const temp = wordToHex(a) + wordToHex(b) + wordToHex(c) + wordToHex(d);
  return temp.toLowerCase();
};

class NebulaSDKCore {
  constructor() {
    setTimeout(() => {
      this.circulateNotifyServer();
    }, 1e3);
  }
  get version() {
    return "3.3.58";
  }
  get debug() {
    return this.state.debug;
  }
  set debug(value) {
    if (value) {
      console.warn([
        "调试信息：",
        `当前接入版本：${this.version}，有问题可先尝试更新最新版SDK`,
        "调试模式已开启，小程序正式版调试模式无效，上线后请务必将调试状态关闭！！！",
        "调试模式下调用方法或者属性会进行调试数据上报，用于对接状态查看和问题排查",
        "调试结果查看：星云开放平台 → 游戏中心 → 选择游戏 → 对接中心 → SDK 对接 → SDK 调试 → H5 → 小游戏 SDK → SDK 调试"
      ].join("\n"));
    }
    this.state.debug = value;
  }
  state = {
    debug: false,
    circulateNotifyTimer: 0
  };
  get notifyList() {
    return this.localStorage.getItem("NEBULA_SDK_CORE_NOTIFY_LIST") || [];
  }
  set notifyList(notifyInfo) {
    this.localStorage.setItem("NEBULA_SDK_CORE_NOTIFY_LIST", notifyInfo);
  }
  stringify(data) {
    const stringifyList = [];
    for (const key in data) {
      const value = data[key];
      if (value === null || value === void 0)
        continue;
      stringifyList.push(`${key}=${value}`);
    }
    return stringifyList.join("&");
  }
  md5(value) {
    return md5(value);
  }
  get deviceId() {
    const deviceStorageKey = "NEBULA_SDK_CORE_DEVICE_ID";
    const deviceId = this.localStorage.getItem(deviceStorageKey);
    if (deviceId)
      return deviceId;
    const signValue = `${this.version}${this.getRandomValues().join("")}${Date.now()}`;
    const deviceRandomId = this.md5(signValue);
    this.localStorage.setItem(deviceStorageKey, deviceRandomId);
    return deviceRandomId;
  }
  getRandomValues(length = 8) {
    const characterCodeList = "ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678";
    const characterValueList = [];
    for (let i = 0; i < length; i++) {
      const character = characterCodeList.charAt(
        Math.floor(Math.random() * characterCodeList.length)
      );
      characterValueList.push(character);
    }
    return characterValueList;
  }
  signature(singArgs, signKey) {
    const signNonce = this.getRandomValues().join("");
    const singValues = { ...singArgs, sign_type: "md5", sign_nonce: signNonce, sign_version: "1.0" };
    const signKeys = Object.keys(singValues).sort();
    const signValueList = Array.from(signKeys, (key) => {
      const value = singValues[key];
      if (value === null || value === void 0)
        return null;
      return `${key}=${value}`;
    });
    const signStringValue = signValueList.filter((v) => v !== null).join("&");
    let signStringCode = encodeURIComponent(signStringValue);
    signStringCode = signStringCode.replace(/!/ug, "%21");
    signStringCode = signStringCode.replace(/\*/ug, "%2A");
    signStringCode = signStringCode.replace(/'/ug, "%27");
    signStringCode = signStringCode.replace(/\(/ug, "%28");
    signStringCode = signStringCode.replace(/\)/ug, "%29");
    singValues.sign = this.md5(`${signStringCode}&${signKey}`);
    return singValues;
  }
  async request(args) {
    if (args.method === "GET") {
      return await this.httpRequest.get(args);
    }
    if (args.method === "POST") {
      return await this.httpRequest.post(args);
    }
    if (args.method === "PUT") {
      return await this.httpRequest.put(args);
    }
    if (args.method === "DELETE") {
      return await this.httpRequest.delete(args);
    }
    throw new Error("request method not support");
  }
  async circulateNotifyServer(count = 1) {
    if (!this.suppprt())
      return;
    if (this.notifyList.length === 0)
      return;
    const successKeyList = await Promise.all(Array.from(this.notifyList, async (notifyItem) => {
      try {
        const { status } = await this.request(JSON.parse(notifyItem.value));
        return status === "error" ? notifyItem.key : null;
      } catch (error) {
        this.log({ code: -1, msg: "订单回调失败", data: error });
      }
    }));
    this.notifyList = this.notifyList.filter(({ key }) => successKeyList.includes(key));
    this.state.circulateNotifyTimer = setTimeout(() => {
      if (count > 10) {
        this.notifyList = [];
        return;
      }
      this.circulateNotifyServer(count + 1);
    }, count * 1e3);
  }
  async requestAccount(args) {
    args.url = `${"https://gate-nebula.737.com"}${args.url}`;
    return await this.request(args);
  }
  async requestPayment(args) {
    args.url = `${"https://api.feiyu.com"}${args.url}`;
    return await this.request(args);
  }
  async requestNotify(args) {
    const value = JSON.stringify(args);
    const key = this.md5(value);
    this.notifyList = [...this.notifyList, { key, value }];
    clearTimeout(this.state.circulateNotifyTimer);
    await this.circulateNotifyServer();
  }
  log(args) {
    console.warn(`NebulaSDK: ${args.code} - ${args.msg}`);
    if (!args.data)
      return;
    console.warn(JSON.stringify(args.data));
  }
}

var StatusCodes = /* @__PURE__ */ ((StatusCodes2) => {
  StatusCodes2[StatusCodes2["Success"] = 1e4] = "Success";
  StatusCodes2[StatusCodes2["NoSupport"] = 10001] = "NoSupport";
  StatusCodes2[StatusCodes2["NoInit"] = 10002] = "NoInit";
  StatusCodes2[StatusCodes2["NoLogin"] = 10003] = "NoLogin";
  StatusCodes2[StatusCodes2["ChannelConfigError"] = 10004] = "ChannelConfigError";
  StatusCodes2[StatusCodes2["AggrateOrderError"] = 10005] = "AggrateOrderError";
  StatusCodes2[StatusCodes2["OrderNotifyError"] = 10006] = "OrderNotifyError";
  StatusCodes2[StatusCodes2["PresetOrderError"] = 10007] = "PresetOrderError";
  StatusCodes2[StatusCodes2["ScanCodeOrderError"] = 10008] = "ScanCodeOrderError";
  StatusCodes2[StatusCodes2["LoginError"] = 20001] = "LoginError";
  StatusCodes2[StatusCodes2["PayError"] = 30001] = "PayError";
  StatusCodes2[StatusCodes2["PayCloseError"] = 30002] = "PayCloseError";
  StatusCodes2[StatusCodes2["PayMidasGameError"] = 30003] = "PayMidasGameError";
  StatusCodes2[StatusCodes2["PayMidasGoodsError"] = 30004] = "PayMidasGoodsError";
  StatusCodes2[StatusCodes2["PayServiceCancelError"] = 30005] = "PayServiceCancelError";
  StatusCodes2[StatusCodes2["PayServiceError"] = 30006] = "PayServiceError";
  StatusCodes2[StatusCodes2["PayScanCodeError"] = 30007] = "PayScanCodeError";
  return StatusCodes2;
})(StatusCodes || {});
var PayTypeCodes = /* @__PURE__ */ ((PayTypeCodes2) => {
  PayTypeCodes2[PayTypeCodes2["Midas"] = 1] = "Midas";
  PayTypeCodes2[PayTypeCodes2["Service"] = 2] = "Service";
  PayTypeCodes2[PayTypeCodes2["QRCode"] = 3] = "QRCode";
  return PayTypeCodes2;
})(PayTypeCodes || {});

const request = async (options) => {
  return new Promise((resolve, reject) => {
    const task = wx.request({
      url: options.url,
      data: options.data,
      timeout: options.timeout,
      method: options.method ?? "GET",
      header: options.headers,
      success: (response) => {
        if (response.statusCode !== 200) {
          resolve({ status: "error", msg: "error", data: response.data });
          return;
        }
        const data = response.data;
        if (data.status !== 0) {
          resolve({ status: "error", msg: "error", data: response.data });
          return;
        }
        resolve({ status: "success", msg: "success", data: data.data });
      },
      fail: (error) => {
        reject(error);
      },
      complete(error) {
        if (error?.errMsg !== "request:fail timeout")
          return;
        task.abort();
        console.warn("请求超时");
      }
    });
  });
};
const wechatHttpRequest = {
  get: async (options) => {
    return request({ ...options, method: "GET" });
  },
  post: async (options) => {
    return request({ ...options, method: "POST" });
  },
  put: async (options) => {
    return request({ ...options, method: "PUT" });
  },
  delete: async (options) => {
    return request({ ...options, method: "DELETE" });
  }
};

const wechatLocalStorage = {
  getItem: (key) => {
    return wx.getStorageSync(key);
  },
  setItem: (key, value) => {
    wx.setStorageSync(key, value);
  },
  removeItem: (key) => {
    wx.removeStorageSync(key);
  },
  clear: () => {
    wx.clearStorageSync();
  }
};

class NebulaWeChatGameSDK extends NebulaSDKCore {
  options = null;
  get userInfo() {
    return this.localStorage.getItem("WX_NEBULA_SDK_USER_INFO");
  }
  set userInfo(userInfo) {
    this.localStorage.setItem("WX_NEBULA_SDK_USER_INFO", userInfo);
  }
  get openId() {
    return this.userInfo?.openId ?? "";
  }
  get unionId() {
    return this.userInfo?.unionId ?? "";
  }
  localStorage = wechatLocalStorage;
  httpRequest = wechatHttpRequest;
  checkSupport() {
    if (!this.suppprt()) {
      const checkResult = { status: "error", code: StatusCodes.NoSupport, msg: "当前环境无法运行NebulaSDK", data: null };
      this.log({ code: checkResult.code, msg: checkResult.msg, data: null });
      return checkResult;
    }
    return { status: "success", code: StatusCodes.Success, msg: "成功", data: null };
  }
  checkInit() {
    if (!this.options) {
      const checkResult = { status: "error", code: StatusCodes.NoInit, msg: "请先调用init方法进行初始化", data: null };
      this.log({ code: checkResult.code, msg: checkResult.msg, data: null });
      return checkResult;
    }
    return { status: "success", code: StatusCodes.Success, msg: "成功", data: null };
  }
  checkLogin() {
    if (!this.userInfo) {
      const checkResult = { status: "error", code: StatusCodes.NoLogin, msg: "请先点用login方法进行登录", data: null };
      this.log({ code: checkResult.code, msg: checkResult.msg, data: null });
      return checkResult;
    }
    return { status: "success", code: StatusCodes.Success, msg: "成功", data: null };
  }
  async getWechatLoginCode(count = 1) {
    const getLoginCode = async () => {
      return await new Promise((resolve, reject) => {
        wx.login({
          success: (res) => {
            resolve(res.code);
          },
          fail: (error) => {
            reject(error);
          }
        });
      });
    };
    try {
      return await getLoginCode();
    } catch (error) {
      if (count > 5)
        throw error;
      return await this.getWechatLoginCode(count + 1);
    }
  }
  async getChannleConfig() {
    const { status, data } = await this.signatureRequestAccount({ url: "/pay/channelConfig/get", method: "GET" });
    if (status === "error") {
      this.log({ code: StatusCodes.ChannelConfigError, msg: "获取支付渠道配置失败", data });
      return null;
    }
    return {
      midasOfferId: data.param.midas_offer_id,
      midasExchangeRate: data.param.midas_exchange_rate ? Number(data.param.midas_exchange_rate) : 10,
      androidPayMode: data.param.android_pay_mode,
      iosPayMode: data.param.ios_pay_mode,
      macPayMode: data.param.mac_pay_mode,
      windowsPayMode: data.param.win_pay_mode,
      serviceImage: data.param.pay_guide_image,
      wxAppId: data.param.wx_app_id
    };
  }
  async getRequestConfig() {
    const systemInfo = wx.getSystemInfoSync();
    const { networkType } = await wx.getNetworkType();
    const newworkTypes = { "2g": 0, "3g": 0, "4g": 2, "5g": 3, wifi: 1, unknown: 0, none: 0 };
    const systemTypes = { android: 1, ios: 0, devtools: 2, windows: 2, mac: 2 };
    return {
      company_id: this.options?.config.nbCompanyId,
      app_id: this.options?.config.nbAppId,
      channel_id: this.options?.config.nbChannelId,
      union_id: this.userInfo?.nbUnionId,
      open_id: this.userInfo?.nbOpenId,
      device_id: this.deviceId,
      startup_id: this.deviceId,
      payment_code: this.options?.config.paymentCode,
      passport_code: this.options?.config.passportCode,
      os: systemTypes[systemInfo.platform],
      network_mode: newworkTypes[networkType],
      device_type: systemInfo.model,
      os_version: systemInfo.system,
      sdk_version: this.version,
      timestamp: Math.floor(Date.now() / 1e3),
      is_debug: this.debug ? 1 : 0
    };
  }
  async signatureRequestAccount(args) {
    const presetParams = await this.getRequestConfig();
    const requestParams = this.signature({ ...presetParams, ...args.data }, this.options.config.nbAppKey);
    return await this.requestAccount({ ...args, data: requestParams });
  }
  async singatureRequestPayment(args) {
    const presetParams = await this.getRequestConfig();
    const requestParams = this.signature({ ...presetParams, ...args.data, source: "feiyu" }, this.options.config.appKey);
    return await this.requestPayment({ ...args, data: requestParams });
  }
  async globalRequestDebugger(args) {
    const { miniProgram } = wx.getAccountInfoSync();
    if (!this.debug || miniProgram.envVersion === "release")
      return { status: "success", msg: "success", data: {} };
    const response = {
      status: args.response?.status ?? "success",
      msg: args.response?.msg ?? "",
      status_text: args.response?.status === "error" ? "失败" : "成功",
      data: args.response?.data || ""
    };
    const data = {
      app_id: this.options.config.nbAppId,
      os: "5",
      work_id: this.deviceId,
      sdk: "wechatminigame",
      module: "wechatminigame",
      api: args.action,
      request: JSON.stringify(args.request),
      response: JSON.stringify(response),
      developer: wx.getSystemInfoSync().model
    };
    return await this.httpRequest.post({
      url: `${"https://gate-nebula.737.com"}/open/sdkDebug/reportLog`,
      data: this.signature(data, this.options.config.nbAppKey)
    });
  }
  async createAggregatePayOrder(args) {
    const { status, data } = await this.signatureRequestAccount({
      url: "/pay/order/create",
      method: "POST",
      data: {
        pay_amount: args.goodsPrice,
        game_order_id: args.tradeNo,
        goods_id: args.goodsId,
        goods_name: args.goodsName,
        game_version: this.options?.version,
        player_id: args.playerId,
        role_id: this.md5(args.serverId + args.playerId),
        player_name: args.playerName,
        player_level: args.playerLevel,
        vip_level: args.vipLevel ?? 0,
        server_id: args.serverId,
        user_id: this.userInfo?.openId,
        open_id: this.userInfo?.nbOpenId,
        union_id: this.userInfo?.nbUnionId,
        data_version: "1",
        pay_sign_type: "md5",
        notify_url: args.notifyUrl,
        notify_ext: args.notifyExt,
        payment_channel: args.payType,
        channel_ext: args.channel_ext
      }
    });
    if (status === "error") {
      this.log({ code: StatusCodes.AggrateOrderError, msg: "创建聚合订单失败", data });
      return null;
    }
    return { orderNo: data.order_id, notifyUrl: data.notify_url, data };
  }
  async createPresetPayOrder(args) {
    const { status, data } = await this.singatureRequestPayment({
      url: "/pay/order",
      method: "POST",
      data: {
        pay_amount: args.goodsPrice,
        goods_id: args.goodsId,
        goods_name: args.goodsName,
        app_order_id: args.orderNo,
        app_callback_uri: args.notifyUrl,
        enable_alipay: 0,
        enable_wxpay: 0,
        param_ext: args.ext ? JSON.stringify(args.ext) : ""
      }
    });
    if (status === "error") {
      this.log({ code: StatusCodes.PresetOrderError, msg: "创建预下单失败", data });
      return null;
    }
    return { orderNo: data.order_id, notifyUrl: args.notifyUrl };
  }
  async createScanCodePayOrder(args) {
    const { status, data } = await this.singatureRequestPayment({
      url: "/pay/wxpay/miniPC",
      method: "POST",
      data: { order_id: args.orderNo }
    });
    if (status === "error") {
      this.log({ code: StatusCodes.ScanCodeOrderError, msg: "创建扫码订单失败", data });
      return null;
    }
    const commonParams = await this.getRequestConfig();
    const codeParams = { order_id: args.orderNo, qr_code: data.qr_code, expire_at: data.expire_at };
    const params = this.signature({ ...commonParams, ...codeParams, source: "feiyu" }, this.options.config.appKey);
    const quetry = this.stringify(params);
    return { orderNo: args.orderNo, orderPayUrl: `${"https://api.feiyu.com"}/pay/wxpay/genQrCodeImage?${quetry}` };
  }
  async wechatMidasGamePay(args) {
    const [aggrate, config] = await Promise.all([
      this.createAggregatePayOrder({ ...args, payType: 0 }),
      this.getChannleConfig()
    ]);
    if (!aggrate || !config)
      return { status: "error", code: StatusCodes.PayMidasGameError, msg: "支付失败", data: null };
    try {
      await wx.requestMidasPayment({
        mode: "game",
        env: args.sandbox,
        offerId: config.midasOfferId,
        currencyType: "CNY",
        buyQuantity: args.goodsPrice / 100 * config.midasExchangeRate,
        zoneId: args.zoneId,
        outTradeNo: aggrate.orderNo
      });
      const notifyInfo = this.signature({
        order_id: aggrate.orderNo,
        channel_order_id: args.tradeNo,
        amount: args.goodsPrice,
        sandbox: args.sandbox,
        channel_ext: JSON.stringify({
          zone_id: args.zoneId,
          openid: this.userInfo?.openId,
          unionid: this.userInfo?.unionId,
          pf: 2
        })
      }, this.options.config.nbAppKey);
      this.requestNotify({ url: aggrate.notifyUrl, method: "POST", data: notifyInfo });
      return { status: "success", code: StatusCodes.Success, msg: "支付成功", data: { payType: PayTypeCodes.Midas, orderNo: aggrate.orderNo } };
    } catch (error) {
      this.log({ code: StatusCodes.PayMidasGameError, msg: "微信游戏币支付失败", data: error });
      return { status: "error", code: StatusCodes.PayMidasGameError, msg: "支付失败", data: null };
    }
  }
  async wechatMidasGoodPay(args) {
    const channel_ext = JSON.stringify({ env: args.sandbox, platform: "android", zone_id: args.zoneId, openid: this.userInfo?.openId });
    const [aggrate, config] = await Promise.all([
      this.createAggregatePayOrder({ ...args, payType: 0, channel_ext }),
      this.getChannleConfig()
    ]);
    if (!aggrate || !config)
      return { status: "error", code: StatusCodes.PayMidasGoodsError, msg: "支付失败", data: null };
    return new Promise((resolve) => {
      const wechatGameApi = wx;
      if (!wechatGameApi.requestMidasPaymentGameItem) {
        resolve({ status: "error", code: StatusCodes.PayMidasGoodsError, msg: "微信基础库版本过低不支持直购", data: null });
        return;
      }
      wechatGameApi.requestMidasPaymentGameItem({
        signData: aggrate.data.sign_data,
        paySig: aggrate.data.pay_sig,
        signature: aggrate.data.signature,
        success: () => {
          resolve({ status: "success", code: StatusCodes.Success, msg: "支付成功", data: { payType: PayTypeCodes.Midas, orderNo: aggrate.orderNo } });
        },
        fail: (error) => {
          this.log({ code: StatusCodes.PayMidasGoodsError, msg: "微信直购支付失败", data: error });
          resolve({ status: "error", code: StatusCodes.PayMidasGoodsError, msg: "支付失败", data: null });
        }
      });
    });
  }
  async wechatMidasPay(args) {
    if (this.options?.config.paymentCode === "wechatgame") {
      return await this.wechatMidasGamePay(args);
    }
    if (this.options?.config.paymentCode === "wechatgamedirect") {
      return await this.wechatMidasGoodPay(args);
    }
    return { status: "error", code: StatusCodes.PayError, msg: "该渠道支付方式暂未支持", data: null };
  }
  async wechatServicePay(args) {
    const { cancel } = await wx.showModal({
      content: "请进入客服会话充值，如果未收到本订单支付入口，请在客服会话中发送“cz”或“充值”或点击右下角图片获取",
      confirmText: "去充值"
    });
    if (cancel)
      return { status: "error", code: StatusCodes.PayServiceCancelError, msg: "取消支付", data: null };
    const aggrate = await this.createAggregatePayOrder({ ...args, payType: 1 });
    if (!aggrate)
      return { status: "error", code: StatusCodes.AggrateOrderError, msg: "创建聚合订单失败", data: null };
    const config = await this.getChannleConfig();
    if (!config)
      return { status: "error", code: StatusCodes.ChannelConfigError, msg: "获取支付渠道配置失败", data: null };
    const presetExt = { wxpay_app_id: config.wxAppId, wxpay_open_id: this.userInfo?.openId };
    const presetArgs = Object.assign(args, aggrate, { ext: presetExt });
    const preset = await this.createPresetPayOrder(presetArgs);
    if (!preset)
      return { status: "error", code: StatusCodes.PresetOrderError, msg: "创建预下单失败", data: null };
    try {
      await wx.openCustomerServiceConversation({
        sessionFrom: this.stringify({
          version: this.version,
          title: "点我进行充值",
          description: `点我充值${(args.goodsPrice / 100).toFixed(2)}元`,
          app_id: this.options?.config.nbAppId,
          channel_id: this.options?.config.nbChannelId,
          order_id: preset.orderNo,
          env: "production",
          path: "/wechat-mini-game",
          pay_amount: args.goodsPrice
        }),
        showMessageCard: true,
        sendMessageTitle: `我要充值${args.goodsPrice / 100}元`,
        sendMessageImg: config.serviceImage
      });
      return { status: "success", code: StatusCodes.Success, msg: "打开客服会话成功", data: { payType: PayTypeCodes.Service, orderNo: preset.orderNo } };
    } catch (error) {
      if (error.errMsg === "openCustomerServiceConversation:fail cancel") {
        return { status: "error", code: StatusCodes.PayServiceCancelError, msg: "取消支付", data: null };
      }
      return { status: "error", code: StatusCodes.PayServiceError, msg: "打开客服会话失败", data: null };
    }
  }
  async wechatScanCodePay(args) {
    const aggrate = await this.createAggregatePayOrder({ ...args, payType: 1 });
    if (!aggrate)
      return { status: "error", code: StatusCodes.AggrateOrderError, msg: "创建聚合订单失败", data: null };
    const preset = await this.createPresetPayOrder({ ...args, ...aggrate });
    if (!preset)
      return { status: "error", code: StatusCodes.PresetOrderError, msg: "创建预下单失败", data: null };
    const scanCode = await this.createScanCodePayOrder({ ...args, ...preset });
    if (!scanCode)
      return { status: "error", code: StatusCodes.ScanCodeOrderError, msg: "创建扫码订单失败", data: null };
    await wx.previewImage({ urls: [scanCode.orderPayUrl] });
    return { status: "success", code: StatusCodes.Success, msg: "支付成功", data: { payType: PayTypeCodes.QRCode, orderNo: scanCode.orderNo } };
  }
  async defaultClosePay() {
    await wx.showModal({
      content: "由于相关规范，暂不提供充值服务",
      showCancel: false,
      confirmText: "好的"
    });
    return { status: "error", code: StatusCodes.PayCloseError, msg: "支付失败", data: null };
  }
  suppprt() {
    if (typeof wx === "undefined")
      return false;
    if (typeof GameGlobal === "undefined")
      return false;
    if (!wx.getStorageSync)
      return false;
    if (!wx.setStorageSync)
      return false;
    if (!wx.getSystemInfoSync)
      return false;
    if (!wx.getStorageSync)
      return false;
    if (!wx.setStorageSync)
      return false;
    if (!wx.request)
      return false;
    return true;
  }
  async initAction(args) {
    const supportResult = this.checkSupport();
    if (supportResult.status === "error")
      return Promise.resolve(supportResult);
    this.options = args;
    return Promise.resolve({ status: "success", code: 1e4, msg: "成功", data: { nbAppId: args.config.nbAppId, nbChannelId: args.config.nbChannelId } });
  }
  async init(args) {
    if (args.debug === true || args.debug === false) {
      this.debug = args.debug;
    }
    const initResult = await this.initAction(args);
    this.globalRequestDebugger({ action: "init", request: args, response: initResult });
    this.globalRequestDebugger({ action: "initCallback", request: args, response: initResult });
    return initResult;
  }
  async loginAction() {
    const supportResult = this.checkSupport();
    if (supportResult.status === "error")
      return Promise.resolve(supportResult);
    const initResult = this.checkInit();
    if (initResult.status === "error")
      return Promise.resolve(initResult);
    const code = await this.getWechatLoginCode();
    const { version, config } = this.options;
    const { status, data } = await this.signatureRequestAccount({
      url: "/account/user/detail",
      method: "POST",
      data: { game_version: version, user_id: "0", code, passport_code: config.passportCode }
    });
    if (status === "error")
      return { status: "error", code: StatusCodes.LoginError, msg: "登录失败", data: null };
    this.userInfo = {
      openId: data.user.user_id,
      unionId: data.user.u_id,
      token: data.token,
      nbOpenId: data.open_id,
      nbUnionId: data.union_id
    };
    return { status: "success", code: 1e4, msg: "登录成功", data: { ...this.userInfo, nbOpendId: data.open_id } };
  }
  async login() {
    this.globalRequestDebugger({ action: "login", request: null, response: null });
    const loginResult = await this.loginAction();
    this.globalRequestDebugger({ action: "loginCallback", request: null, response: loginResult });
    return loginResult;
  }
  async androidPayAction(args, config) {
    switch (config.androidPayMode) {
      case "0":
        return this.defaultClosePay();
      case "1":
        return this.wechatMidasPay(args);
      case "2":
      case "3":
        return this.wechatServicePay(args);
      default:
        return this.defaultClosePay();
    }
  }
  async iosPayAction(args, config) {
    switch (config.iosPayMode) {
      case "0":
        return this.defaultClosePay();
      case "1":
      case "2":
      case "3":
        return this.wechatServicePay(args);
      default:
        return this.defaultClosePay();
    }
  }
  async macPayAction(args, config) {
    switch (config.macPayMode) {
      case "0":
        return this.defaultClosePay();
      case "1":
        return this.wechatMidasPay(args);
      case "2":
        return this.wechatServicePay(args);
      case "3":
        return this.wechatScanCodePay(args);
      default:
        return this.defaultClosePay();
    }
  }
  async windowsPayAction(args, config) {
    switch (config.windowsPayMode) {
      case "0":
        return this.defaultClosePay();
      case "1":
        return this.wechatMidasPay(args);
      case "2":
        return this.wechatServicePay(args);
      case "3":
        return this.wechatScanCodePay(args);
      default:
        return this.defaultClosePay();
    }
  }
  async devtoolsPayAction(args) {
    if (this.debug) {
      console.warn([
        "调试信息：",
        "当前在开发者工具下可以选择不同支付方式进行支付，移动端访问会根据平台和配置自动调用支付方式",
        "微信内购原生支付必须商品ID和商品价格与微信后台一致否则无法拉起支付",
        "客服支付跳转到客服后结果返回成功，跳转到客服已经离开的游戏无法检测用户是否支付",
        "扫码支付生成二维码后结果返回成功，弹出二维码无法检测用户是否进行扫码支付",
        "方法调用成功都会返回支付订单号和支付类型，支付成功状态主要以服务端通知为基准",
        "不同的支付方式根据返回值payType进行处理，支付类型：1=原生支付、2=客服支付、3=二维码支付"
      ].join("\n"));
    }
    try {
      const { tapIndex } = await wx.showActionSheet({
        alertText: "选择支付方式",
        itemList: ["内购支付", "客服支付", "扫码支付", "关闭支付"]
      });
      switch (tapIndex) {
        case 0:
          return this.wechatMidasPay(args);
        case 1:
          return this.wechatServicePay(args);
        case 2:
          return this.wechatScanCodePay(args);
        case 3:
          return this.defaultClosePay();
        default:
          return this.defaultClosePay();
      }
    } catch (error) {
      this.log({ code: StatusCodes.PayError, msg: "支付失败", data: error });
      return { status: "error", code: StatusCodes.PayError, msg: "支付失败", data: null };
    }
  }
  async payAction(args) {
    const supportResult = this.checkSupport();
    if (supportResult.status === "error")
      return Promise.resolve(supportResult);
    const initResult = this.checkInit();
    if (initResult.status === "error")
      return Promise.resolve(initResult);
    const loginResult = this.checkLogin();
    if (loginResult.status === "error")
      return Promise.resolve(loginResult);
    const config = await this.getChannleConfig();
    if (!config)
      return { status: "error", code: StatusCodes.ChannelConfigError, msg: "获取支付渠道配置失败", data: null };
    const { errMsg } = await wx.checkSession();
    if (errMsg !== "checkSession:ok") {
      await this.login();
    }
    const systemInfo = wx.getSystemInfoSync();
    switch (systemInfo.platform) {
      case "android":
        return this.androidPayAction(args, config);
      case "ios":
        return this.iosPayAction(args, config);
      case "mac":
        return this.macPayAction(args, config);
      case "windows":
        return this.windowsPayAction(args, config);
      case "devtools":
        return this.devtoolsPayAction(args);
      default:
        return this.defaultClosePay();
    }
  }
  async pay(args) {
    this.globalRequestDebugger({ action: "pay", request: args, response: null });
    const payResult = await this.payAction(args);
    this.globalRequestDebugger({ action: "payCallback", request: args, response: payResult });
    return payResult;
  }
}
const nebulaSDKInstance = new NebulaWeChatGameSDK();
{
  GameGlobal.NebulaDebug = (debug) => {
    nebulaSDKInstance.debug = Boolean(debug);
  };
  GameGlobal.NebulaInit = async (args) => {
    if (typeof args.config === "string") {
      args.config = JSON.parse(args.config);
    }
    const initResult = await nebulaSDKInstance.init(args);
    GameGlobal.Module.SendMessage("NebulaSDKBridgeCallback", "NebulaSDKInitCallback", JSON.stringify(initResult));
  };
  GameGlobal.NebulaLogin = async () => {
    const loginResult = await nebulaSDKInstance.login();
    GameGlobal.Module.SendMessage("NebulaSDKBridgeCallback", "NebulaSDKLoginCallback", JSON.stringify(loginResult));
  };
  GameGlobal.NebulaPay = async (args) => {
    const PayResult = await nebulaSDKInstance.pay(args);
    GameGlobal.Module.SendMessage("NebulaSDKBridgeCallback", "NebulaSDKPayCallback", JSON.stringify(PayResult));
  };
}

exports.NebulaWeChatGameSDK = NebulaWeChatGameSDK;
exports.default = nebulaSDKInstance;
